import cv2
import numpy as np
import os
import sys
import math

PB1 = 14
hs1 = 6
fs1 = 6
hs2 = 1361
mb1 = 15000
bb1 = np.zeros(mb1, dtype=np.uint8)
bb2 = np.zeros(mb1 * 2 + 1, dtype=np.uint8)
th1 = 0
pf1 = ""

def oh1(bf1, nb1):
    hv1 = 0
    for i in range(nb1):
        hv1 ^= bf1[i]
    return hv1

def wf1(pd1, pc1, pt1, fn1):
    fe1 = os.path.isfile(fn1)
    oh2 = bytearray(hs1)
    of1 = bytearray(fs1)
    hv1 = hs2 ^ oh1(pd1, pc1 * PB1)
    if not fe1:
        oh2[0] = 2
    else:
        oh2[0] = (pt1 >> 16) & 0x7F
    oh2[1] = (pt1 >> 8) & 0xFF
    oh2[2] = pt1 & 0xFF
    oh2[3] = pc1
    oh2[4] = (hv1 >> 8) & 0xFF
    oh2[5] = hv1 & 0xFF
    of1[0] = ((pt1 >> 16) & 0x7F) | 0x80
    of1[1] = (pt1 >> 8) & 0xFF
    of1[2] = pt1 & 0xFF
    of1[3] = pc1
    of1[4] = (hv1 >> 8) & 0xFF
    of1[5] = hv1 & 0xFF
    with open(fn1, 'ab+') as f:
        f.write(oh2)
        f.write(pd1[:pc1 * PB1])
        f.write(of1)

def si1(fn1):
    global th1
    with open(fn1, 'ab+') as f:
        f.seek(0, 2)
        if f.tell() <= 1:
            bb2[0] = (th1 >> 8) & 0xFF
            bb2[1] = th1 & 0xFF
            f.write(bb2[:th1 * 4 + 2])
        f.write(bb1[:th1 + 2])

def cb1(xs1, xe1, ys1, ye1, bs1, im1):
    def cb2(px1, py1, bv1):
        global th1
        bb2[th1 * 4 + 2] = (px1 >> 8) & 0xFF
        bb2[th1 * 4 + 1 + 2] = px1 & 0xFF
        bb2[th1 * 4 + 2 + 2] = (py1 >> 8) & 0xFF
        bb2[th1 * 4 + 3 + 2] = py1 & 0xFF
        bb1[th1 + 2] = bv1
        th1 += 1

    def ca1(px1, py1, bs1):
        bx1 = im1[py1:py1 + bs1, px1:px1 + bs1]
        return np.mean(bx1)

    vs1 = [
        ((xs1 + xe1) // 2, ys1 - 50),
        ((xs1 + xe1) // 2, ye1 + 60),
        (xs1 - 50, (ys1 + ye1) // 2),
        (xs1 + (xs1 + xe1) // 20, (ys1 + ye1) // 4),
        (xs1 + (xs1 + xe1) // 2 - 50, (ys1 + ye1) * 3 // 4)
    ]
    for px1, py1 in vs1:
        bv1 = ca1(px1, py1, 100)
        cb2(px1, py1, int(bv1))

def pe1(xs1, xe1, ys1, ye1, im1, ss1):
    global th1
    cx1 = (xe1 - xs1) // 2
    cy1 = (ye1 - ys1) // 2 + ys1
    lx1 = xe1 - xs1
    ly1 = ye1 - ys1
    gb1 = 4

    for y in range(ys1, ye1 - ss1, ss1):
        cd1 = abs(y - cy1) if y < cy1 else abs(y + ss1 - cy1)
        hd1 = (ly1 / 2 - gb1)

        if ly1 > 0:
            cx2 = math.sqrt(abs(hd1 * hd1 - cd1 * cd1))
            da1 = (lx1 / ly1) * cx2
            cx1 = int(da1)

        xi1 = xs1 + cx1 - cx2 + ss1 // 2
        xf1 = xs1 + cx1 + cx2 - ss1 // 2

        for x in range(int(xi1), int(xf1) - int(ss1), int(ss1)):
            mi1 = 255
            ai1 = 0
            px1, py1 = 0, 0
            for y2 in range(0, ss1, ss1 // 4):
                for x2 in range(ss1):
                    cp1 = im1[y + y2, x + x2]
                    px1 += cp1
                    if cp1 < mi1:
                        mi1 = cp1
                px1 //= ss1
            for x2 in range(0, ss1, ss1 // 4):
                for y2 in range(ss1):
                    cp1 = im1[y + y2, x + x2]
                    py1 += cp1
                    if cp1 < mi1:
                        mi1 = cp1
                py1 //= ss1

            ai1 = (px1 + py1) // 2
            bb1[th1 + 2] = ai1
            bb2[th1 * 4 + 2] = ((x + ss1 // 2) >> 8) & 0xFF
            bb2[th1 * 4 + 3] = (x + ss1 // 2) & 0xFF
            bb2[th1 * 4 + 4] = ((y + ss1 // 2) >> 8) & 0xFF
            bb2[th1 * 4 + 5] = (y + ss1 // 2) & 0xFF

            th1 += 1

def pa1():
    ag1 = {}
    for a in sys.argv[1:]:
        if a.startswith('-'):
            k1 = a[:3]
            v1 = a[3:]
            if v1 == '':
                raise ValueError(f"Argumento {k1} necesita un valor.")
            ag1[k1] = v1
    return ag1

def gp1(nf1):
    pf1 = os.path.dirname(nf1)
    if pf1.endswith("img"):
        pf1 = os.path.dirname(pf1)
    return pf1

def main():
    ag1 = pa1()
    fi1 = ag1.get('-fi')
    xs1 = int(ag1.get('-xs'))
    xe1 = int(ag1.get('-xe'))
    ys1 = int(ag1.get('-ys'))
    ye1 = int(ag1.get('-ye'))
    pl1 = int(ag1.get('-pl'))
    ph1 = int(ag1.get('-ph'))
    ll1 = int(ag1.get('-ll'))
    lh1 = int(ag1.get('-lh'))
    bs1 = int(ag1.get('-bs'))
    ti1 = int(ag1.get('-ti'))
    im1 = cv2.imread(fi1, cv2.IMREAD_GRAYSCALE)
    pf1 = gp1(fi1)
    ss1 = bs1
    bb1[0] = (ti1 >> 8) & 0xFF
    bb1[1] = ti1 & 0xFF
    cb1(xs1, xe1, ys1, ye1, bs1, im1)
    pe1(xs1, xe1, ys1, ye1, im1, ss1)
    fn1 = os.path.join(pf1, "xy_image.bin")
    si1(fn1)
    bl1 = cv2.GaussianBlur(im1, (5, 5), 0)
    th2 = cv2.adaptiveThreshold(bl1, 255, cv2.ADAPTIVE_THRESH_GAUSSIAN_C, 
                                cv2.THRESH_BINARY_INV, 11, 2)
    kr1 = np.ones((5, 5), np.uint8)
    er1 = cv2.erode(th2, kr1, iterations=1)
    op1 = cv2.dilate(er1, kr1, iterations=2)
    mk1 = np.zeros_like(im1)
    cx1 = (xs1 + xe1) // 2
    cy1 = (ys1 + ye1) // 2
    ax1 = (xe1 - xs1) // 2
    ay1 = (ye1 - ys1) // 2
    cv2.ellipse(mk1, (cx1, cy1), (ax1, ay1), 0, 0, 360, 255, -1)
    mi1 = cv2.bitwise_and(th2, th2, mask=mk1)
    ct1, _ = cv2.findContours(mi1, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
    pt1 = bytearray(len(ct1) * PB1)
    i2 = 0
    for i, c in enumerate(ct1):
        ar1 = int(cv2.contourArea(c))
        if pl1 < ar1 < ph1:
            m = cv2.moments(c)
            if m["m00"] != 0:
                pcx1 = int(m["m10"] / m["m00"])
                pcy1 = int(m["m01"] / m["m00"])
                x, y, plx1, ply1 = cv2.boundingRect(c)
                if (ll1 <= plx1 <= lh1) and (ll1 <= ply1 <= lh1):
                    i2 = i2 + 1                
                    pm1 = np.zeros_like(im1)
                    cv2.drawContours(pm1, [c], -1, 255, thickness=cv2.FILLED)
                    pv1 = im1[pm1 == 255]
                    pb2 = int(pv1.mean())
                    obp1 = (i2-1) * PB1
                    pt1[obp1 + 0] = i2
                    pt1[obp1 + 1] = (pcx1 >> 8) & 0xFF
                    pt1[obp1 + 2] = pcx1 & 0xFF
                    pt1[obp1 + 3] = (pcy1 >> 8) & 0xFF
                    pt1[obp1 + 4] = pcy1 & 0xFF
                    pt1[obp1 + 5] = (ar1 >> 8) & 0xFF
                    pt1[obp1 + 6] = ar1 & 0xFF
                    pt1[obp1 + 7] = (plx1 >> 8) & 0xFF
                    pt1[obp1 + 8] = plx1 & 0xFF
                    pt1[obp1 + 9] = (ply1 >> 8) & 0xFF
                    pt1[obp1 + 10] = ply1 & 0xFF
                    pt1[obp1 + 11] = 0
                    pt1[obp1 + 12] = 0
                    pt1[obp1 + 13] = pb2
    fn1 = os.path.join(pf1, "xy_worms.bin")
    wf1(pt1, i2, ti1, fn1)
    print(f"Partículas detectadas: {i2} de {len(ct1)}")

if __name__ == "__main__":
    main()
